import ComplexType from './complex';
import { JSONSchemaOptions } from './json-schema-output';
import { MongooseOutputOptions } from './mongoose-output';
import { Schema as SchemaType } from './schema';
import { TSOptions } from './ts-output';
export declare const ObjectId: "object-id-a639ebb1-afcc-42df-b838-6b53a8fe301f";
export declare type Schema = SchemaType;
export declare const Complex: typeof ComplexType;
export declare const now = "now-b9759814-a87f-4193-bbf8-c1003db19515";
export declare type MongooseOutputOptionsWithOptionalContext = Omit<MongooseOutputOptions, 'context'> & {
    context?: string;
};
export declare function createMongooseSchema(schema: Schema, contextOrOptions?: MongooseOutputOptionsWithOptionalContext | string): import("./mongoose-output").MongooseFields;
export declare function createTypescriptInterfaceDefinition(exportName: string, schema: Schema | ComplexType, context?: string, options?: TSOptions): string;
export declare function createJSONSchema(schema: Schema, context?: string, options?: JSONSchemaOptions): import("./json-schema-output").JSONSchema;
export declare function createTypescriptInterfaceFiles(sourceFileGlobOrFileArray: string | string[], outputPath: string, logCreations?: boolean): Promise<void>;
export interface TypescriptSchemaDefinition {
    name: string;
    context?: string;
    omitExtraExports?: boolean;
    schema?: Schema | ComplexType;
    exportHash?: string;
    doNotImportObjectId?: boolean;
}
export declare function createTSInterfaceFile(filename: string, outputPath: string, logCreations?: boolean, formatOutputFilename?: typeof defaultOutputFilenameFormatter): Promise<void>;
declare function defaultOutputFilenameFormatter(inputFilename: string): string;
export declare function hashSchema(schema: Schema | ComplexType): string;
export {};
