"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.COMPLEX_IDENTITY = void 0;
const json_schema_output_1 = require("./json-schema-output");
const mongoose_output_1 = require("./mongoose-output");
const ts_output_1 = require("./ts-output");
exports.COMPLEX_IDENTITY = 'complex-30753295-84f7-486b-bc21-b224461736ee';
class Complex {
    constructor(subschema) {
        this.subschema = subschema;
    }
    get _schematarIdentity() {
        return exports.COMPLEX_IDENTITY;
    }
    outputTypescript(context, indentation, _field) {
        return ('{\n' + [...ts_output_1.outputFields(this.subschema, context, indentation + '  ')].join('\n') + '\n' + indentation + '}');
    }
    outputMongoose(options, _field) {
        return { plain: mongoose_output_1.outputFields(this.subschema, options) };
    }
    outputJSONSchema(context, options, _field) {
        const subschema = {
            type: 'object',
            required: [],
            properties: {},
            additionalProperties: !!options.allowAdditionalFieldsNested,
        };
        json_schema_output_1.outputFields(this.subschema, context, subschema, options);
        return subschema;
    }
    static isComplex(potentialComplex) {
        return !!(potentialComplex && potentialComplex._schematarIdentity === exports.COMPLEX_IDENTITY);
    }
}
exports.default = Complex;
