import { Schema, SchemaFields } from './schema';
interface JSONSchemaSimpleProperty {
    type: string;
}
interface JSONSchemaArrayProperty {
    type: string;
    items: JSONSchemaProperty;
}
interface JSONSchemaStringProperty {
    type: 'string';
    pattern?: string;
    enum?: string[];
}
interface JSONSchemaAnyProperty {
}
interface JSONSchemaMultiTypeProperty {
    type: string[];
}
export declare type JSONSchemaProperty = JSONSchemaSimpleProperty | JSONSchemaObjectProperty | JSONSchemaStringProperty | JSONSchemaArrayProperty | JSONSchemaAnyProperty | JSONSchemaMultiTypeProperty;
interface JSONSchemaProperties {
    [key: string]: JSONSchemaProperty;
}
export interface JSONSchemaObjectProperty {
    type: 'object';
    properties: JSONSchemaProperties;
    required: string[];
    additionalProperties: boolean;
}
export interface JSONSchema extends JSONSchemaObjectProperty {
    $id: string;
    $schema: 'http://json-schema.org/draft-07/schema#';
}
export interface JSONSchemaOptions {
    makeEverythingOptional?: boolean;
    allowAdditionalFields?: boolean;
    allowAdditionalFieldsNested?: boolean;
    schemaId?: string;
}
export default function (schema: Schema, context?: string, options?: JSONSchemaOptions): JSONSchema;
export declare function outputFields(fields: SchemaFields, context: string, schema: JSONSchemaObjectProperty, options: JSONSchemaOptions): void;
export {};
