import { Field, Schema, SchemaFields } from './schema';
export interface MongooseOutputOptions {
    context: string;
    transformer?(input: MongooseField, path: string[], schematarType: Field): MongooseField | undefined;
    _fieldPath?: string[];
}
export interface MongooseFields {
    [key: string]: MongooseField;
}
interface MongooseField {
    type: any;
    index?: boolean;
    unique?: boolean;
    sparse?: boolean;
    enum?: any[];
    ref?: string;
    default?: any;
    expires?: string;
}
export declare type MongooseTypeBase = {
    type: any;
} | {
    plain: any;
};
export default function (schema: Schema, options: MongooseOutputOptions): MongooseFields;
export declare function outputFields(fields: SchemaFields, options: MongooseOutputOptions): MongooseFields;
export {};
