import Complex from './complex';
import { ObjectId } from './object-id';
export declare type DefaultContext = 'mongoose' | 'typescript' | 'jsonschema';
export interface Schema {
    fields: SchemaFields;
}
declare type SimpleType = Complex | typeof String | typeof Number | typeof Boolean | typeof Date | typeof Object | typeof ObjectId | Schema;
declare type IndexOptions = false | true | 'unique' | 'unique-sparse';
export declare type PlainType = SimpleType | Array<FieldInfo | SimpleType>;
export declare type Field = FieldInfo | PlainType;
export interface FieldInfo {
    type: PlainType;
    index?: IndexOptions;
    format?: any;
    optional?: boolean;
    allowNull?: boolean;
    presentIn?: string[];
    optionalIn?: string[];
    enum?: string[];
    mongoose?: any;
    mongooseDefault?: any;
    mongooseRef?: string;
    mongooseExpires?: string;
    jsonSchema?: any;
}
export interface SchemaFields {
    [name: string]: Field;
}
export declare function isFullDeclaration<Context>(field: Field): field is FieldInfo;
export declare function isSchema(potentialSchema: any): potentialSchema is Schema;
export {};
